#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <stdarg.h>
#include "main.h"
#include "transactions.h"
#include "rcv.h"
#include "spam.h"

static char *last_join_address[255][16];

void
setspam(struct htlc_conn *htlc, u_int32_t type)
{
	long ul;
	ul=sizeof(unsigned long)*8;

        if(type < 1000){	
	if (hxd_cfg.spam.value[type] < ldexp(ul, ul)-1)
		htlc->spamcurrent += hxd_cfg.spam.value[type];
	else
		htlc->spamcurrent += hxd_cfg.spam.value[0];
	}
	else
		htlc->spamcurrent += hxd_cfg.spam.value[0];

}

int
resetspamcurrent(u_int64_t *t)
{
	struct htlc_conn *htlcp;
	for (htlcp = htlc_list->next; htlcp; htlcp = htlcp->next) {
		if(htlcp->uid == t){
			htlcp->spamcurrent=0;
			/* in case we change config file need to re set timer */
			if(htlcp->uid){
			timer_delete_ptr(t);
			timer_add_secs(hxd_cfg.spam.spamcheck, resetspamcurrent, t);
			}
			return;
			}
	}
}

int
remove_lastaddr(char *c)
{
	int i=0;
        while(!strcmp(last_join_address[i], c)) {
		i++;
	}
	if(i>0)
		i--;
	if(i==0)
		timer_delete_ptr(c);
	else {
		timer_delete_ptr(c);
		timer_add_secs(i*i, remove_lastaddr, c);
	}
	last_join_address[i][0] = '\0';
	return 0;
}

void
add_lastaddr(char *c)
{
	int i=0;
	while(strlen(last_join_address[i]))
		i++;
	sprintf(last_join_address[i], c);
}

int
cmp_lastaddr(char *address)
{
	int i=0;
	while(strlen(last_join_address[i])) {
		if(!strcmp(last_join_address[i], address))
			if(i>0)
				return i;
			else
				return 1;
		i++;
	}
		return 0;
}
